C
C     Program to construct boundaries around each continent from
C     plate boundary file, and to construct a plate area file
C
      implicit real*8 (a-h,o-z)
      character*2 pln(2,100),pl(100),plar(7200)
      character*60 bdrys,bdrys2,plates
      integer npt(100),npt2(25,100),npl2(100),npt3(100),npt4(100)
      real lat(1000,100),long(1000,100),lat2(25,1000,22),
     2 long2(25,1000,22),lat3(2000,22),long3(2000,22),
     3 latfin,longfin,latpt,longpt,x1(2000),x2(2000),y1(2000),
     4 y2(2000),z1(2000),z2(2000)
      parameter (pi=3.141592654)

      print *,'plate boundary input file?'
      read (5,1100) bdrys
 1100 format (a60)
      open (8,file=bdrys)
      read (8,1000)
 1000 format (60x)
      read (8,*) npl
      jpl=2
      do j=1,npl
        read (8,1000)
        read (8,1001) pln(1,j),pln(2,j)
        if (j.eq.1) then
          pl(1)=pln(1,j)
          pl(2)=pln(2,j)
        else
          do i=1,jpl
            if (pln(1,j).eq.pl(i)) goto 199
          enddo
          jpl=jpl+1
          pl(jpl)=pln(1,j)
  199     do i=1,jpl
            if (pln(2,j).eq.pl(i)) goto 299
          enddo
          jpl=jpl+1
          pl(jpl)=pln(2,j)
        endif
 1001   format (a2,1x,a2)
  299   read (8,*) npt(j)
        do i=1,npt(j)
          read (8,*) lat(i,j),long(i,j)
 1002     format (f6.2,2x,f6.2)
        enddo
      enddo
      close(8)
C
C     Assign boundaries to their respective plates, with the plate always
C     on the left side
C
      do k=1,jpl
        ipl=0
        npt3(k)=0
        do j=1,npl
          if (pl(k).eq.pln(1,j)) then
            ipl=ipl+1
            npt2(ipl,k)=npt(j)
            npt3(k)=npt3(k)+npt(j)
            do i=1,npt(j)
              lat2(ipl,i,k)=lat(i,j)
              long2(ipl,i,k)=long(i,j)
            enddo
          else if (pl(k).eq.pln(2,j)) then
            ipl=ipl+1
            npt2(ipl,k)=npt(j)
            npt3(k)=npt3(k)+npt(j)
            do i=1,npt(j)
              lat2(ipl,i,k)=lat(npt(j)+1-i,j)
              long2(ipl,i,k)=long(npt(j)+1-i,j)
            enddo
          endif
        enddo
        npl2(k)=ipl
      enddo
C
C     Order plate boundary segments to a closed loop
C
      do k=1,jpl
        jpt=0
        do j=1,npt2(1,k)
          jpt=jpt+1
          lat3(jpt,k)=lat2(1,j,k)
          long3(jpt,k)=long2(1,j,k)
        enddo
        latfin=lat2(1,npt2(1,k),k)
        longfin=long2(1,npt2(1,k),k)
        do i=2,npl2(k)
          do l=2,npl2(k)
            if ((lat2(l,1,k).eq.latfin).and.
     2          (long2(l,1,k).eq.longfin)) then
              do j=2,npt2(l,k)
                jpt=jpt+1
                lat3(jpt,k)=lat2(l,j,k)
                long3(jpt,k)=long2(l,j,k)
              enddo
              latfin=lat2(l,npt2(l,k),k)
              longfin=long2(l,npt2(l,k),k)
            endif
          enddo
        enddo
      enddo
C
C     Write solution
C
      print *,'plate boundary output file'
      read (5,1100) bdrys2
      open (9,file=bdrys2)
      do k=1,21
        write (9,1003) pl(k)
 1003   format (a2)
        write (9,1004) npt3(k)-npl2(k)+1
        npt4(k)=npt3(k)-npl2(k)+1
 1004   format (i3)
        do i=1,npt3(k)-npl2(k)+1
          write (9,1002) lat3(i,k),long3(i,k)
        enddo
      enddo
      close(9)
C
C     For each point, find out which continent it is on
C
      print *,'plate area output file'
      read (5,1100) plates
      print *,'grid spacing (in degrees)'
      read *,grid
      nlong=360/grid
      nlat=nlong/2.-1
      open (9,file=plates)
      do ilat=-(nlat-1)/2,(nlat-1)/2
        do ilong=1,nlong
          latpt=-grid*ilat
          longpt=grid*(ilong-1)
          xpt=cos(latpt*pi/180.)*cos(longpt*pi/180.)
          ypt=cos(latpt*pi/180.)*sin(longpt*pi/180.)
          zpt=sin(latpt*pi/180.)
          do k=1,21
            thetot=0.
            do i=1,npt3(k)-npl2(k)+1
C
C     Determine angle between point and the boundary segment
C     Step 1: Cross-product
C
              x1(i)=cos(lat3(i,k)*pi/180.)*cos(long3(i,k)*pi/180.)
              y1(i)=cos(lat3(i,k)*pi/180.)*sin(long3(i,k)*pi/180.)
              z1(i)=sin(lat3(i,k)*pi/180.)
              x2(i)=y1(i)*zpt-z1(i)*ypt
              y2(i)=z1(i)*xpt-x1(i)*zpt
              z2(i)=x1(i)*ypt-y1(i)*xpt
C
C    Step 2: Normalize
C
              r2abs=sqrt(x2(i)*x2(i)+y2(i)*y2(i)+z2(i)*z2(i))
              x2(i)=x2(i)/r2abs
              y2(i)=y2(i)/r2abs
              z2(i)=z2(i)/r2abs
            enddo
C
C    Step 3: Sum up angles
C
            do i=1,npt3(k)-npl2(k)
              x3=y2(i)*z2(i+1)-z2(i)*y2(i+1)
              y3=z2(i)*x2(i+1)-x2(i)*z2(i+1)
              z3=x2(i)*y2(i+1)-y2(i)*x2(i+1)
              costhe=x2(i)*x2(i+1)+y2(i)*y2(i+1)+z2(i)*z2(i+1)
              if (xpt*xpt.gt.0.25) sinthe=x3/xpt
              if (ypt*ypt.gt.0.25) sinthe=y3/ypt
              if (zpt*zpt.gt.0.25) sinthe=z3/zpt
              if (sinthe.gt.1) sinthe=1.
              if (sinthe.lt.-1) sinthe=-1.
              if (costhe.gt.0) then         
                theta=asin(sinthe)
              else if ((costhe.lt.0).and.(sinthe.gt.0)) then
                theta=pi-asin(sinthe)
              else
                theta=-pi-asin(sinthe)
              endif
              thetot=thetot+theta
            enddo
            if (thetot.gt.6.) then
              plar(ilong)=pl(k)
              goto 99
            endif
          enddo
   99     idumb=0.
          write (9,2712) latpt,longpt,plar(ilong)
 2712     format (2f6.1,1x,a2)
        enddo
        print *,ilat,ilong,thetot,pl(k)
      enddo
      close(9)
      end
      
