C
C      Program to decide whether we are on the plate (in cartesian coordinates)
C
      implicit real*8(a-h,o-z)
      dimension rlat(2000),rlon(2000)
      pi=3.141592654
      do j=1,1000
        read (5,*,end=99) rlat(j),rlon(j)
      enddo
  99  jout=j-1
      do ilat=-580,420
C        do ilon=-350,720
        do ilon=-500,1300
C        do ilon=300,1500
          plat=ilat*0.1
          plon=ilon*0.1
          call whichplate(jout,rlat,rlon,plat,plon,anglesum)
          if ((anglesum.lt.-6.).or.(anglesum.gt.6)) then
              write (6,*) plat,plon
          endif
        enddo
      enddo
      end

      subroutine whichplate(naround,therd,phird,thept,phipt,thetot)

      implicit real*8 (a-h,o-z)
C
C     Figure out, which plate we are on
C
      dimension therd(2000),phird(2000),x1(2000),x2(2000),y1(2000),
     2 y2(2000),z1(2000),z2(2000)
      parameter (pi=3.14159265358979324D0)

 300  xpt=cos(thept*pi/180.)*cos(phipt*pi/180.)
      ypt=cos(thept*pi/180.)*sin(phipt*pi/180.)
      zpt=sin(thept*pi/180.)

      thetot=0.
      do i=1,naround
C
C     Determine angle between point and the boundary segment
C     Step a: Cross-product
C
        x1(i)=cos(therd(i)*pi/180.)*cos(phird(i)*pi/180.)
        y1(i)=cos(therd(i)*pi/180.)*sin(phird(i)*pi/180.)
        z1(i)=sin(therd(i)*pi/180.)
        x2(i)=y1(i)*zpt-z1(i)*ypt
        y2(i)=z1(i)*xpt-x1(i)*zpt
        z2(i)=x1(i)*ypt-y1(i)*xpt
C
C    Step b: Normalize
C
        r2abs=sqrt(x2(i)*x2(i)+y2(i)*y2(i)+z2(i)*z2(i))
        if (r2abs.eq.0) return
        x2(i)=x2(i)/r2abs
        y2(i)=y2(i)/r2abs
        z2(i)=z2(i)/r2abs
      enddo
C
C    Step c: Sum up angles
C
      do i=1,naround-1
        x3=y2(i)*z2(i+1)-z2(i)*y2(i+1)
        y3=z2(i)*x2(i+1)-x2(i)*z2(i+1)
        z3=x2(i)*y2(i+1)-y2(i)*x2(i+1)
        costhe=x2(i)*x2(i+1)+y2(i)*y2(i+1)+z2(i)*z2(i+1)
        if (xpt*xpt.gt.0.25) sinthe=x3/xpt
        if (ypt*ypt.gt.0.25) sinthe=y3/ypt
        if (zpt*zpt.gt.0.25) sinthe=z3/zpt
        if (sinthe.gt.1) sinthe=1.
        if (sinthe.lt.-1) sinthe=-1.
        if (costhe.gt.0) then         
          theta=asin(sinthe)
        else if ((costhe.lt.0).and.(sinthe.gt.0)) then
          theta=pi-asin(sinthe)
        else
          theta=-pi-asin(sinthe)
        endif
        thetot=thetot+theta
      enddo

      if ((thetot.lt.-2*pi-0.01)
     2 .or.((thetot.gt.-2*pi+0.01).and.(thetot.lt.-0.01))
     3 .or.((thetot.gt.0.01).and.(thetot.lt.2*pi-0.01))
     4 .or.(thetot.gt.2*pi+0.01)) then
        print *,thetot,'Something wrong'
        do i=1,naround
          print *,therd(i),phird(i)
        enddo
C        stop
      endif

      return
      end
