C
C     Rotating set of data points for a given rotation vector
C
      implicit real*8(a-h,o-z)
      dimension tmat(3,3),ommat(3,3),tau(3),xpres(3),xpast(3)
      parameter (pi=3.14159265358979324,conv=pi/180.)
      character*60 surftrace,surftrace2
C
C     Input rotation
C
      read (5,*) rlat,rlong,absrot
      plwx=-absrot*cos(rlat*conv)*cos(rlong*conv)        
      plwy=-absrot*cos(rlat*conv)*sin(rlong*conv)        
      plwz=-absrot*sin(rlat*conv) 
      read (5,6001) surftrace
      read (5,6001) surftrace2
      read (5,*) ncolumn
 6001 format (a60)
      open (2,file=surftrace)       
      open (8,file=surftrace2)
      do l=1,9900000
        if (ncolumn.eq.2) read (2,*,end=102) rlong,rlat 
        if (ncolumn.eq.3) read (2,*,end=102) rlong,rlat,z 
C
C     Calculate the rotation matrix
C
        tau(1)=plwx*conv
        tau(2)=plwy*conv
        tau(3)=plwz*conv
        rho=sqrt(tau(1)*tau(1)+tau(2)*tau(2)+tau(3)*tau(3))
        tmat(1,1)=0.
        tmat(1,2)=-tau(3)
        tmat(1,3)=tau(2)
        tmat(2,1)=tau(3)
        tmat(2,2)=0.
        tmat(2,3)=-tau(1)
        tmat(3,1)=-tau(2)
        tmat(3,2)=tau(1)
        tmat(3,3)=0.
        do i=1,3
          do j=1,3
            tmatsq=0.
            do k=1,3
              tmatsq=tmatsq+tmat(i,k)*tmat(k,j)
            enddo
            if (rho.eq.0) then
              ommat(i,j)=0.
            else
              ommat(i,j)=sin(rho)*tmat(i,j)/rho+
     2                   (1-cos(rho))*tmatsq/(rho*rho)
            endif
            if (i.eq.j) ommat(i,j)=ommat(i,j)+1.
          enddo
        enddo
C
C     Rotated position at past time
C
        xpres(1)=cos(rlong*conv)*cos(rlat*conv)
        xpres(2)=sin(rlong*conv)*cos(rlat*conv)
        xpres(3)=sin(rlat*conv)
        xpast(1)=ommat(1,1)*xpres(1)+ommat(1,2)*xpres(2)
     2          +ommat(1,3)*xpres(3)
        xpast(2)=ommat(2,1)*xpres(1)+ommat(2,2)*xpres(2)
     2          +ommat(2,3)*xpres(3)
        xpast(3)=ommat(3,1)*xpres(1)+ommat(3,2)*xpres(2)
     2          +ommat(3,3)*xpres(3)
C
C      Latitude and longitude at past time
C        
        if (xpast(1).gt.0) then
          rlong=atan(xpast(2)/xpast(1))/conv
        else if ((xpast(1).lt.0).and.(xpast(2).ge.0)) then
          rlong=atan(xpast(2)/xpast(1))/conv+180.
        else if ((xpast(1).lt.0).and.(xpast(2).lt.0)) then
          rlong=atan(xpast(2)/xpast(1))/conv-180.
        else if ((xpast(1).eq.0).and.(xpast(2).ge.0)) then
          rlong=90.
        else if ((xpast(1).eq.0).and.(xpast(2).lt.0)) then
          rlong=-90.
        endif
        if ((xpast(1).eq.0).and.(xpast(2).eq.0)
     2      .and.(xpast(3).gt.0)) then
          rlat=90.
        else if ((xpast(1).eq.0).and.(xpast(2).eq.0)
     2      .and.(xpast(3).lt.0)) then
          rlat=-90.
        else
          rlat=atan(xpast(3)/sqrt(xpast(1)*xpast(1)+
     2                            xpast(2)*xpast(2)))/conv
        endif
 1004   format (2f10.4)
        if (ncolumn.eq.2) write (8,1004) rlong,rlat
        if (ncolumn.eq.3) write (8,1004) rlong,rlat,z
      enddo
  102 close(8)
      close(2)
      end
